\ start by loading the constants
load ../../dataDictionary/common/common.4th

: nullCalc 0 ;

: evtStringField ot_STRING st_UNKNOWN pt_UNKNOWN kl_UNDEFINED fc_UNDEFINED ;

: ft_evt_ms ( -- ft )       [  evtStringField s" ft_evt_ms" nullCalc FieldTypeDefine ] LITERAL ;
: ft_evt_server ( -- ft )   [ evtStringField s" ft_evt_server" nullCalc FieldTypeDefine ] LITERAL ;
: ft_evt_type ( -- ft )     [ evtStringField s" ft_evt_type" nullCalc FieldTypeDefine ] LITERAL ;
: ft_evt_severity ( -- ft ) [ evtStringField s" ft_evt_severity" nullCalc FieldTypeDefine ] LITERAL ;
: ft_evt_name ( -- ft )     [ evtStringField s" ft_evt_name" nullCalc FieldTypeDefine ] LITERAL ;
: ft_evt_value ( -- ft )    [ evtStringField s" ft_evt_value" nullCalc FieldTypeDefine ] LITERAL ;
: ft_evt_address ( -- ft ) ft_agent_IP ;
: ft_evt_ifindex ( -- ft ) ft_DS ;
: ft_evt_url ( -- ft )      [ evtStringField s" ft_evt_url" nullCalc FieldTypeDefine ] LITERAL ;
: ft_evt_comment ( -- ft )  [ evtStringField s" ft_evt_comment" nullCalc FieldTypeDefine ] LITERAL ;

: streamIdField ot_OBJECT st_UNKNOWN pt_UNKNOWN kl_STREAMID fc_FLOW ;

\ interface (ft_stream_id) is a disk column in other views, but here we have to synthesize it
: ft_event_stream_id ( -- ft ) [ streamIdField s" ft_event_stream_id" ft_agent_IP ft_DS 2 implicitCalc FieldTypeDefine ] LITERAL ;
: ft_event_streamPath [ agentPathStringField s" ft_event_streamPath" ft_event_stream_id 1 ' getPathForStream calc_ONHEAP CalcNew FieldTypeDefine dup cd_CONFIG FieldTypeAddCacheDep ] LITERAL ;

\ the events view expects 'ifindex' to be ds_class:ds_index, i.e. ft_DS
: ft_ifIndex ( -- ft ) ft_DS ;

\ ft_evt_timestamp is the seconds version, so we need to divide by 1000.
\ The input is a string so we just need to lop 3 characters off the end
\ as long as it is > 3 characters long
: ms_to_s ( ms -- s )
count dup 3 > IF 3 - THEN ot_STRING ObjectAsCell ;

: ft_evt_timestamp ( -- ft ) [ evtStringField s" ft_evt_timestamp" ft_evt_ms 1 ' ms_to_s calc_ONHEAP CalcNew FieldTypeDefine ] LITERAL ;

: eventFileSpec { -- tspec }
	TableSpecNew
                dup ft_evt_ms addKey
                dup ft_evt_server addKey
                dup ft_evt_severity addKey
                dup ft_evt_type addKey
                dup ft_evt_name addKey
                dup ft_evt_value addKey
                dup ft_agent_IP addKey
                dup ft_DS addKey
                dup ft_evt_url addKey
                dup ft_evt_comment addKey
		\ add these conjured fields too so they can be filtered on
                \ even if not in the select list for the query tablespec
                dup ft_rows addValue
                dup ft_input_row addKey
                dup ft_file_seconds addKey
                dup ft_event_id addKey
		dup ft_evt_timestamp addKey
 ;

: processTable ( table | -- ) nullTime 32 printTable ;  \ 32=only print last N

: endGroup { results | -- } results .table_or_emptyRow ;

: runQuery ( walker -- ) 
    dup IntervalWalkSpec                                     \ ( walker spec -- )
        dup eventFileSpec TableSpecSetTextFileSpec           \ ( walker spec -- )
        ft_event_id TableSpecIncludesField IF                \ ( walker -- )
           0 ['] processTable 0 IntervalWalkTextQueryHT
        ELSE
           0 0 ['] endGroup IntervalWalkTextQueryHT
        THEN
;

: runWalkSetQuery { walkSet -- }
        \ walkSet ['] setQueryType WalkSetDo
        walkSet ['] runQuery WalkSetDo
;

: ft_evt_classtype_in ( -- ft ) [ evtStringField s" ft_evt_classtype_in" nullCalc FieldTypeDefine ] LITERAL ;
: ft_evt_msg_in ( -- ft )       [ evtStringField s" ft_evt_msg_in" nullCalc FieldTypeDefine ] LITERAL ;

: rulesMetaMapSpec ( -- spec )
	TableSpecNew
		dup ft_evt_comment ignoreColumn  \ meta-tag
		dup ft_evt_value addKey          \ sid is the key
		dup ft_evt_classtype_in agg_FIRST sort_NONE addColumn  \ value 0
		dup ft_evt_msg_in agg_FIRST sort_NONE addColumn        \ value 1
;

256 string RULESINI  s" rules.ini" RULESINI place
256 string RULESPATTERN s" ^; __meta__," RULESPATTERN place
256 string RULESDELIM s" ," RULESDELIM place

: rulesMetaTable ( -- table )
   rulesMetaMapSpec CONFIGDIR count RULESINI count 0 RULESDELIM count 0 RULESPATTERN count TableSpecParseFile ;

variable RULESMETAMAP 0 RULESMETAMAP !
: rulesMetaMap ( -- map )
  RULESMETAMAP @ ?dup 0= IF
    rulesMetaMapSpec MapNew dup 1 MapSetPreAggregation
    rulesMetaTable \ ( map table -- )
    over TableAddTo \ ( map -- )
    dup RULESMETAMAP !
  THEN ;

: sidToClassType ( sid -- classtype ) rulesMetaMap 0 MapLookupAt ;
: sidToMsg ( sid -- msg ) rulesMetaMap 1 MapLookupAt ;

: ft_evt_classtype ( -- ft ) [ evtStringField s" ft_evt_classtype" ft_evt_value 1 ' sidToClassType calc_STATIC CalcNew FieldTypeDefine ] LITERAL ;
: ft_evt_msg ( -- ft )       [ evtStringField s" ft_evt_msg" ft_evt_value 1 ' sidToMsg calc_STATIC CalcNew FieldTypeDefine ] LITERAL ;
         
\ important to have a cr after the last ';' to make sure the last word gets compiled
