// Copyright (c) InMon Corp. 2014 ALL RIGHTS RESERVED

(function($) {
    $.fn.chart = function(settings, db) {
	var $chartDiv = $(this);
        var db = db;

	var defaults = {
            type  : 'trend',
	    stack: false,
            sep: ',',
            keyName: function(key) { return key; },
	    otherStr: '-other-'
	};
	var option = $.extend(defaults,settings);
        var clickable = 'topn' == option.type;
        var widget = $(this).stripchart({clickable:clickable});
	var selectedTime = 0;
        if(clickable) {
           $chartDiv.bind('stripchartclick', function(e,pt) {
	       var bins = db.trend.times.length;
	       var selectedBin = Math.floor((bins * pt.x) + 0.5);
	       if(selectedBin < 0) selectedBin = 0;
	       if(selectedBin > (bins - 1)) selectedTime = 0;
	       else selectedTime = db.trend.times[selectedBin];
	       drawChart();
           });
        } 

        var selectedTime = 0;

	function drawChart() {
	    if(!db.trend) {
		console.log("drawChart: nothing to draw: db=" + db);
		return;
	    }
	    
	    switch(option.type) {
	    case "trend":
		var cdata = {times:db.trend.times, values:[], colors:option.colors, units:option.units, stack:option.stack, threshold:option.threshold};
		for(var i = 0; i < option.metrics.length; i++) cdata.values.push(db.trend.trends[option.metrics[i]]);
                if(option.legend) cdata.legend = {labels:option.legend};
		widget.stripchart("draw", cdata);
		break;
	    case "topn":
		var cdata = {times:db.trend.times, units:option.units,stack:option.stack, threshold:option.threshold};
		var idx;
		if(selectedTime >= db.trend.times[0]) {
		    for(idx = 0; idx < db.trend.times.length; idx++) {
			if(db.trend.times[idx] >= selectedTime) break;
		    }
		} else {
		    selectedTime = 0;
		    idx = db.trend.times.length - 1;
		}
                cdata.selectedIdx = idx;

		var topn = db.trend.trends[option.metric];
		var lines = [];
		var labels = [];
		if(selectedTime >= db.trend.times[0]) {
		    for(idx = 0; idx < db.trend.times.length; idx++) {
			if(db.trend.times[idx] >= selectedTime) break;
		    }
		} else {
		    selectedTime = 0;
		    idx = db.trend.times.length -1;
		}

		var legend = topn[idx];
		var sortedKeys = [];
		for(var k in legend) {
		    if(option.otherStr != k) sortedKeys.push(k);
		}
		sortedKeys.sort(function(a,b) { return legend[b] - legend[a]; });
		sortedKeys.push("hidden");

		var keyToIdx = {};
		var seriesOptions = [];
		for(var k in sortedKeys) {
		    var key = sortedKeys[k];
		    var line = new Array(db.trend.times.length);
		    for(var i = 0; i < line.length; i++) line[i] = 0;
		    lines[k] = line;
		    keyToIdx[sortedKeys[k]] = k;
		    if("hidden" != key) labels[k] = $.map(key.split(option.sep),option.keyName);
		}
		var otherLine = lines[sortedKeys.length - 1];
		for(var i = 0; i < db.trend.times.length; i++) {	
		    var entry = topn[i];
		    for(var key in entry) {
			var val = (entry[key] || 0); 
			if(key in keyToIdx) {
			    lines[keyToIdx[key]][i] = val;
			}
			else {
			    if(option.stack) otherLine[i] += val;
			}
			if(!option.stack) otherLine[i] = Math.max(otherLine[i], val);
		    }
		}
		var cvals = option.colors;
		var colors = [];
		for(var i = 0; i < labels.length; i++) {
		    colors.push(cvals[i % cvals.length]);
		}
		colors.push(option.otherColor || 'darkgray');
		cdata.colors = colors;
		cdata.values = lines;
                cdata.legend = {labels:labels,headings:option.legendHeadings};
		widget.stripchart("draw", cdata);
		break;
	    }
        }
	$(document).on('updateChart', function(e) {
                if($chartDiv.is(':visible')) drawChart();
	});
	return this;
    }
}(jQuery));
