(function($) {
  $.jqplot.StepRenderer = function() {
    $.jqplot.LineRenderer.call(this);
  };
  $.jqplot.StepRenderer.prototype = new $.jqplot.LineRenderer();
  $.jqplot.StepRenderer.prototype.constructor = $.jqplot.StepRenderer;

  var _prevStep;
  $.jqplot.StepRenderer.prototype.draw = function(ctx, gd, options, plot) {
    var pd = this._plotData;
    var xmin = this._xaxis.min;
    var xmax = this._xaxis.max;
    var ymin = this._yaxis.min;
    var ymax = this._yaxis.max;
    var xp = this._xaxis.series_u2p;
    var yp = this._yaxis.series_u2p;

    var opts = $.extend(true, {}, options);
    var shadow = (opts.shadow != undefined) ? opts.shadow : this.shadow;
    var showLine = (opts.showLine != undefined) ? opts.showLine : this.showLine;
    var fill = (opts.fill != undefined) ? opts.fill : this.fill;
    var fillAndStroke = (opts.fillAndStroke != undefined) ? opts.fillAndStroke : this.fillAndStroke;

    ctx.save();
    if(gd.length) {
      if(this.showLine) {
         if(fill) {
           var pstep = [];
           if(this.index == 0 || !this._stack) {
             _prevStep = [];
             pstep.push([xp(pd[0][0]),yp(this.fillToValue)]);
             for(var i = 0; i < pd.length; i++) {
               var x = xp(pd[i][0]);
               var y = yp(pd[i][1]);

               pstep.push([x,y]);
               _prevStep.push([x,y]);
          
               // extend step
               var nextPoint = pd[i+1];
               if(nextPoint) {
                  pstep.push([xp(nextPoint[0]),y]);
                  _prevStep.push([xp(nextPoint[0]),y]);
               }
               else {
                 // extend series to end of last interval
                  if(i > 0) {
                    var deltaX = pd[i][0] - pd[i-1][0];
                    pstep.push([xp(pd[i][0] + deltaX), y]);
                    _prevStep.push([xp(pd[i][0] + deltaX), y]);
                  } 
                }
              }
              pstep.push([pstep[pstep.length - 1][0],yp(this.fillToValue)]);
           }
           else {
              pstep.push(_prevStep[0]);
              var prevStep = [];
              for(var i = 0; i < pd.length; i++) {
                var x = xp(pd[i][0]);
                var y = yp(pd[i][1]);

                pstep.push([x,y]);
                prevStep.push([x,y]);
          
                // extend step
                var nextPoint = pd[i+1];
                if(nextPoint) {
                   pstep.push([xp(nextPoint[0]),y]);
                   prevStep.push([xp(nextPoint[0]),y]);
                }
                else {
                  // extend series to end of last interval
                  if(i > 0) {
                    var deltaX = pd[i][0] - pd[i-1][0];
                    pstep.push([xp(pd[i][0] + deltaX), y]);
                    prevStep.push([xp(pd[i][0] + deltaX), y]);
                  } 
               }
             }
             for(var i = _prevStep.length; i > 0; i--) {
               pstep.push(_prevStep[i - 1]);
             }
             _prevStep = prevStep;           
           }
             
           if(shadow) this.renderer.shadowRenderer.draw(ctx,pstep,opts);
           this.renderer.shapeRenderer.draw(ctx,pstep,opts);
         }
         else {
           var pstep = [];
           for(var i = 0; i < pd.length; i++) {
             var x = xp(pd[i][0]);
             var y = yp(pd[i][1]);

             pstep.push([x,y]);
          
             // extend step
             var nextPoint = pd[i+1];
             if(nextPoint) pstep.push([xp(nextPoint[0]),y]);
             else {
               // extend series to end of last interval
               if(i > 0) {
                 var deltaX = pd[i][0] - pd[i-1][0];
                 pstep.push([xp(pd[i][0] + deltaX), y]);
               } 
            }
          }
          this.renderer.shapeRenderer.draw(ctx,pstep,opts);
        }
      }
    }
    ctx.restore();
  }  
})(jQuery);
