String.prototype.startsWith = function(str) {
  return (this.match("^"+str)==str);
}

var Log = {
    elem: false,
    write: function(text){
        //if (!this.elem) 
        //    this.elem = document.getElementById('log');
        //this.elem.innerHTML = text;
        //this.elem.style.left = (500 - this.elem.offsetWidth / 2) + 'px';
    }
};

function addEvent(obj, type, fn) {
    if (obj.addEventListener) obj.addEventListener(type, fn, false);
    else obj.attachEvent('on' + type, fn);
};

var json = {};

function drawMap() {
    function get(id) {
      return document.getElementById(id);  
    };
    var infovis = document.getElementById('map');
    var w = infovis.offsetWidth, h = infovis.offsetHeight;
    //init canvas
    //Create a new canvas instance.
    var canvas = new Canvas('mycanvas', {
        'injectInto': 'map',
        'width': w,
        'height': h
    });
    //end
    
    var style = document.getElementById('mycanvas').style;
    style.marginLeft = style.marginTop = "25px";
    //init Hypertree
    var ht = new Hypertree(canvas, {
        //Change node and edge styles such as
        //color, width and dimensions.
        Node: {
            dim: 9,
            color: "#f00",
            overridable: true
        },
        
        Edge: {
            lineWidth: 2,
            color: "#088"
        },
        
        onBeforeCompute: function(node){
            Log.write("centering");
        },
        //Attach event handlers and add text to the
        //labels. This method is only triggered on label
        //creation
        onCreateLabel: function(domElement, node){
            domElement.innerHTML = node.name;
            addEvent(domElement, 'click', function () {
	        // change the on click method for neighbors
                if(node.id.startsWith('h-')) window.location = $hosturl + node.data.host;
                else ht.onClick(node.id);
            });
        },
        //Change node styles when labels are placed
        //or moved.
        onPlaceLabel: function(domElement, node){
            var style = domElement.style;
            style.display = '';
            style.cursor = 'pointer';
            if (node._depth <= 1) {
                style.fontSize = "0.8em";
                style.color = "#000";

            } else if(node._depth == 2){
                style.fontSize = "0.7em";
                style.color = "#555";

            } else {
                style.display = 'none';
            }

            var left = parseInt(style.left);
            var w = domElement.offsetWidth;
            style.left = (left - w / 2) + 'px';
        },
        
        onAfterCompute: function(){
            Log.write("done");
            
            //Build the right column relations list.
            //This is done by collecting the information (stored in the data property) 
            //for all the nodes adjacent to the centered node.
            var node = Graph.Util.getClosestNodeToOrigin(ht.graph, "pos");
            var html = "<h4>" + node.name + "</h4><b>Connections:</b>";
            html += "<ul>";
            Graph.Util.eachAdjacency(node, function(adj){
                var child = adj.nodeTo;
                if (child.data) {
                    var rel = (child.data.band == node.name) ? child.data.relation : node.data.relation;
                    html += "<li>" + child.name + " " + "<div class=\"relation\">(relation: " + rel + ")</div></li>";
                }
            });
            html += "</ul>";
            document.getElementById('inner-details').innerHTML = html;
        }
    });
    
    //load JSON data.
    ht.loadJSON(json);
    //compute positions and plot.
    ht.refresh();
    //end
    ht.controller.onAfterCompute();

}

function newNodeData(xml) {
  var xml = $(xml);
  var host = xml.find('host');
  var id = host.attr('id');
  var protocols = [];
  
  json = {
    "id": id,
    "name": host.attr('name'),
    "data": {},
    "children": protocols
  };

  xml.find('protocol').each(function() {
    var protocol = $(this);
    var pid = protocol.attr('id') + "-" + protocol.attr('type');
    var hosts = [];
    var direction = protocol.attr('type') == 'client' ? '-' : '+';
    var name = direction + ' ' + protocol.attr('name');
    var child = {
      "id": pid,
      "name": name,
      "data": { "$color":"#088" },
      "children": hosts
    };
    protocols.push(child);
    protocol.find('host').each(function(i) {
      // limit the number of nodes
      if(i < 20) {
      var host = $(this);
      var child = {
        "id": 'h-' + pid + '-' + host.attr('id'),
        "name": host.attr('name'),
        "data": { "host": host.attr('id') },
        "children": []
      };
      hosts.push(child);
      }
    });
  });
}

$.fn.image = function(src, f){ 
   return this.each(function(){ 
     var i = new Image(); 
     i.src = src; 
     i.onload = f; 
     this.appendChild(i);
  }); 
} 

$(document).ready(function() {
   $.ajax({
      url: $url,
      dataType: "xml",
      success: function(xml) { newNodeData(xml); drawMap(); },
      error: function(xhr,desc,ex) { $("#map").html("<p>" + xhr.status + "</p>"); }
     }); 
   //$('#trend').image($charturl);   
});
