function Widget(id,url,type,refresh,reload,redraw) {
  this.id = id;
  this.url = url;
  this.type = type;
  this.refresh = refresh;
  this.seconds = 0;
  this.reload = reload;
  this.redraw = redraw;
}

Widget.jqID = function(id) {
  return "#" + id.replace(/:/g,"\\:").replace(/\./g,"\\.");
}

Widget.toggleControls = function(id)
{
  //var style = document.getElementById(id).style;
  //style.display = style.display ? "":"block";
  $(Widget.jqID(id)).slideToggle("fast");
}

Widget.list = new Array();

Widget.addInstance = function(id,url,type,refresh,redraw) {
  this.list.push(new Widget(id,url,type,refresh,redraw));
}

Widget.request = function() {
  var req;
  if(window.XMLHttpRequest) {
    req = new XMLHttpRequest();
    //if(req.overrideMimeType) req.overrideMimeType("text/html");
  }
  else if(window.ActiveXObject) {
    req = new ActiveXObject("Microsoft.XMLHTTP");
  }
  return req;
}

Widget.get = function(wid) {
  for(var i = 0; i < this.list.length; i++) {
    if(this.list[i].id == wid) return this.list[i];
  }
  return null;
}

Widget.decodePre = function(encoded) {
  var decoded = encoded.replace(/&amp;/g,"&");
  decoded = decoded.replace(/&lt;/g,"<");
  decoded = decoded.replace(/&gt;/g,">");
  decoded = decoded.replace(/&guot;/g,'"');
  decoded = decoded.replace(/&#039;/g,"'");
  decoded = decoded.replace(/&#092;/g,"\\");
  return decoded;
}

Widget.settings = function(cntrlid,wid) {
  var div = document.getElementById(cntrlid);
  // input fields
  var inputs = div.getElementsByTagName("input");
  var args = "&action=set";
  for(var i = 0; i < inputs.length; i++) {
    inputs[i].style.background = "#ffffff";
    var name = inputs[i].name;
    var val = inputs[i].value;
    args += "&" + encodeURIComponent(name) + "=" + encodeURIComponent(this.decodePre(val));
    if("title" == name) {
       var titleid = wid.replace("body.","title.");
       var heading = document.getElementById(titleid);
       if(heading) {
          var newText = document.createTextNode(val);
          var oldText = heading.childNodes[0];
          if(oldText) heading.replaceChild(newText,heading.childNodes[0]);
          else heading.appendChild(newText);
       }
    }
  }
  // select fields
  var selects = div.getElementsByTagName("select");
  for(var i = 0; i < selects.length; i++) {
    var name = selects[i].name;
    var val = selects[i].options[selects[i].selectedIndex].value;
    args += "&" + encodeURIComponent(name) + "=" + encodeURIComponent(val);
  }

  var w = Widget.get(wid);
  var url = w.url;

  var req;

  var processStateChange = function() {
    if(req.readyState == 4) {
      if(req.status == 200) {
        var response = req.responseXML;
	if(response) {
           var result = response.getElementsByTagName("result")[0];
	   var succeeded = result.getAttribute("succeeded");
           if(succeeded == "false") {
	      var errors = result.getElementsByTagName("error");
	      if(errors) {
                for(var i = 0; i < errors.length; i++) {
                   var inputname = errors[i].getAttribute("input");
                   for( var j = 0; j < inputs.length; j++) {
                      if(inputs[j].name == inputname) inputs[j].style.background = "#ffcccc";
                   }
                }
              }
	   }
        }

        if(w.reload) {
          var sURL = unescape(window.location.pathname);
          window.location.href = sURL;
        }
        else w.redraw = true;
      }
    }
  }

  req = Widget.request();
  if(req) {
    req.onreadystatechange = processStateChange;
    var parts = url.split("?");
    args = parts[1] + args;
    req.open("POST",parts[0],true);
    req.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    req.setRequestHeader("Content-length", args.length);
    req.setRequestHeader("Connection", "close");
    req.send(args);
  }
}

Widget.prototype.refreshImage = function(ms) {
  var div = document.getElementById(this.id);
  var images = div.getElementsByTagName("img");
  var img = images[0];
  var newurl = this.url + "&ms=" + ms;

  var newImg = document.createElement("img");
  if(newImg.complete == undefined) {
    newImg.completed = false;
    newImg.onload = function() { newImg.completed = true; };
  }
  newImg.setAttribute("src",newurl);

  // wait for image to load before swapping
  function showimg() {
     if (newImg.complete || newImg.completed) {
          div.replaceChild(newImg,img);
      } else {
          setTimeout(function () {showimg();},200);
      }
    }
    showimg();
}

Widget.prototype.refreshHTML = function(ms) {
  var div = document.getElementById(this.id);
  var newurl = this.url + "&ms=" + ms;

  var req;

  var processStateChange = function() {
    if(req.readyState == 4) {
      if(req.status == 200) {
        var response = req.responseText;
        div.innerHTML = response;
      }
    }
  }

  req = Widget.request();
  if(req) {
    req.onreadystatechange = processStateChange;
    req.open("GET",newurl,true);
    req.send("");
  }
}

Widget.refreshInstances = function() {
  var ms = (new Date()).getTime();
  for(var i = 0; i < Widget.list.length; i++) {
     var inst = Widget.list[i];
     inst.seconds++;
     if(inst.redraw || (inst.refresh > 0 && inst.seconds >= inst.refresh)) {
       inst.seconds = 0;
       inst.redraw = false;
       if("png" == inst.type) inst.refreshImage(ms);
       else if("html" == inst.type) inst.refreshHTML(ms);
     }
  }
}

Widget.startRefreshTask = function() {
   // run every second
   window.setInterval(this.refreshInstances,1000);
}

// User functions

Widget.submit = function(wid) {
  var bid = "body." + wid;
  var div = document.getElementById(bid);
  // input fields
  var inputs = div.getElementsByTagName("input");
  var args = "&action=get";
  for(var i = 0; i < inputs.length; i++) {
    var name = inputs[i].name;
    var val = inputs[i].value;
    args += "&" + encodeURIComponent("input_" + name) + "=" + encodeURIComponent(this.decodePre(val));
  }
  // select fields
  var selects = div.getElementsByTagName("select");
  for(var i = 0; i < selects.length; i++) {
    var name = selects[i].name;
    var val = selects[i].options[selects[i].selectedIndex].value;
    args += "&" + encodeURIComponent("input_" + name) + "=" + encodeURIComponent(val);
  }
  
  args += "&resultFormat=html";

  var w = Widget.get(bid);
  var url = w.url;

  var req;

  var processStateChange = function() {
    if(req.readyState == 4) {
      if(req.status == 200) {
  	var div = document.getElementById(w.id);
	div.innerHTML = req.responseText;
      }
    }
  }

  req = Widget.request();
  if(req) {
    req.onreadystatechange = processStateChange;
    var parts = url.split("?");
    args = parts[1] + args;
    req.open("POST",parts[0],true);
    req.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
    req.setRequestHeader("Content-length", args.length);
    req.setRequestHeader("Connection", "close");
    req.send(args);
  }
}

$(document).ready(function() {
  Widget.startRefreshTask();
});


