-----------------------------------------------------------------------
----- Copyright (C) InMon Corp. 2014 ALL RIGHTS RESERVED       --------
----- Module to collect extra metrics from agents              --------
-----------------------------------------------------------------------
local measurement = require("measurement")

local debugAgent = inx.pref("@Poll2DebugAgent") or inx.pref("@PollDebugAgent")
local interval = inx.pref("@SNMPCounterPollInterval") or 60
interval = tonumber(interval)

local pollers = {
   require("pollCpuMem_HR"),
   require("pollCpuMem_HP"),
   require("pollCpuMem_Cisco"),
   require("pollCpuMem_Brocade"),
   require("poll_Force10_E"),
   require("poll_Force10_S"),
   require("pollEnv_EntitySensors"),
}

local function doAgent(ip, objId, up, args)
   for i,v in ipairs(pollers) do
      v.agentCB(ip, objId, up, args)
   end
end

local function agentsChanged(args)
   inx.log(1, "Got callback: agentsChanged")
   inx.agentsDo(doAgent, args)
end

inx.sinkEvent("agentsChanged", agentsChanged, { interval=interval, debugAgent=debugAgent })

local listeners = {
   -- require("listen_VCS"),
}

local poller = { pollers = pollers,  listeners = listeners }
return poller
